## user space stuff
package provide nmc 0.2

namespace eval ::nmc {
	namespace export nmc
}

load [file join [file dirname [info script]] nmc_tcl.so]

rename nmc nmc::_nmc

proc nmc::nmc {n args} {
	if {[llength $args] == 1} {
		return -code error {not enough arguments}
	}
	set n_clean [string map {% {}} $n]
	if {![string is integer $n_clean] || $n_clean < 0} {
		return -code error {n must be an integer zero or greater}
	}
	if {[llength $args] == 2} {
		lassign $args s1 s2
	}
	if {[lindex $args 0] == {-file}} {
		set s1 [slurp [lindex $args 1]]
		set args [lrange $args 2 end]
	} else {
		set s1 [lindex $args 0]
		set args [lrange $args 1 end]
	}
	if {[lindex $args 0] == {-file}} {
		set s2 [slurp [lindex $args 1]]
	} else {
		set s2 [lindex $args 0]
	}

	if {[string index $n end] == {%}} {
		set n [string range $n 0 end-1]
		set max [expr { [string length $s1] < [string length $s2] ? [string length $s1] : [string length $s2] }]
		set n [expr {int(($n/100.0)*$max)}]
		if {$n == 0} {set n 1}
	}
	return [::nmc::_nmc $n $s1 $s2]
}

proc nmc::slurp {file} {
	set fh [open $file r]
	try {
		return [read $fh]
	} finally {
		close $fh
	}
}
