#include <string.h>
#include <tcl.h>
#include "nmc.h"

static int nmc_tcl(ClientData clientData,
              Tcl_Interp *interp,
              int objc, Tcl_Obj *const objv[])
{
        char result[21];

    if ( objc != 4 )
    {
        Tcl_WrongNumArgs (interp, 1, objv,
                                   "n string1 string2");
        return TCL_ERROR;
    }

    int s1_len, s2_len, n;
    Tcl_GetIntFromObj(interp, objv[1], &n);
    char *s1 = Tcl_GetStringFromObj(objv[2], &s1_len);
    char *s2 = Tcl_GetStringFromObj(objv[3], &s2_len);

    if (s1_len > 0 && s2_len > 0){
		snprintf(result, 21, "%.20f",
			nmc ( n, (unsigned char *) s1, s1_len, (unsigned char *) s2, s2_len )
		);
    } else {
		snprintf(result, 21, "%.20f", -1.0);
	}

    Tcl_SetObjResult(interp, Tcl_NewStringObj(result, -1));

    return TCL_OK;
}

int Nmc_tcl_Init(Tcl_Interp *interp)
{
    if (Tcl_InitStubs(interp, "8.6", 0) == NULL) {
    return TCL_ERROR;
    }
    Tcl_CreateObjCommand(interp, "nmc", nmc_tcl,
    (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
    return TCL_OK;
}
